#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <FL/gl.h>

class UserInterface : public Fl_Gl_Window {
public:
  void draw();
  UserInterface(int x = 100, int y = 100, int w = 320, int h = 240)
    : Fl_Gl_Window(x, y, w, h)
  { }
};

void UserInterface::draw() {
  if ( !valid() ) {
    glLoadIdentity();
    glViewport(0, 0, w(), h());
  }
  glClear(GL_COLOR_BUFFER_BIT);
  gl_font(FL_TIMES, 36);
  gl_color(FL_BACKGROUND_COLOR);
  glBegin(GL_POLYGON);
    glVertex3f(-1.0, -1.0, 0.0);
    glVertex3f( 1.0, -1.0, 0.0);
    glVertex3f( 1.0,  1.0, 0.0);
    glVertex3f(-1.0,  1.0, 0.0);
    glVertex3f(-1.0, -1.0, 0.0);
  glEnd();
  gl_color(FL_FOREGROUND_COLOR);
  gl_draw("Hello, world!", -0.9f, -0.9f);
}

int main(int argc, char **argv) {
  UserInterface ui;
  ui.show(argc, argv);
  return Fl::run();
}
